IMAGE_NAME = "generic/rhel8"
BOX_VERSION = "3.0.2"
N = 2

Vagrant.configure("2") do |config|
    #config.ssh.insert_key = false

    config.vm.provider "virtualbox" do |v|
        v.memory = 4096
        v.cpus = 2
    end

    config.vm.define "k8s-master" do |master|
        master.vm.provider "virtualbox" do |gui| 
         gui.name = "k8s-master"
        end
        master.vm.box = IMAGE_NAME
        master.vm.box_version = BOX_VERSION
        master.vm.network "private_network", ip: "10.0.0.10"
        master.vm.network "public_network", ip: "192.168.1.105"
        #master.vm.network "forwarded_port", guest: 8001, host:8001
        master.vm.synced_folder ".", "/vagrant"
        master.vm.provision :shell, :inline => "sudo sed -i 's/PasswordAuthentication no/PasswordAuthentication yes/g' /etc/ssh/sshd_config; sudo systemctl restart sshd;", run: "always"
        master.vm.provision "ansible" do |ansible|
            ansible.playbook = "ansible/new-master-playbook.yml"
            ansible.extra_vars = {
                master_ip: "192.168.1.105",
                hostname: "k8s-master",
	}
        end
    end

    (1..N).each do |i|
        config.vm.define "node-#{i}" do |node|
            node.vm.provider "virtualbox" do |gui|
             gui.name = "k8s-node#{i}"
             gui.memory = 12288
            end
            node.vm.box = IMAGE_NAME
            node.vm.box_version = BOX_VERSION
            node.vm.network "private_network", ip: "10.0.0.#{i + 11}"
            node.vm.network "public_network", ip: "192.168.1.#{i + 105}"
            node.vm.synced_folder ".", "/vagrant"
            node.vm.provision "ansible" do |ansible| 
              ansible.playbook = "ansible/node-playbook.yml"  
              ansible.extra_vars = {                                                              
                  node_ip: "192.168.1.#{i + 105}",
                  hostname: "k8s-node#{i}", 
           }   
          end
      end
    end
end


    
